# Summary

[Introduction](./introduction.md)

--------------------------------------------------------------------------------

- [Basic Usage](./basic-usage.md)
- [What Just Happened?](./what-just-happened.md)
- [What Else Can We Do?](./what-else-can-we-do.md)
- [Closures](./closures.md)
- [Feature Reference](./feature-reference.md)
- [CLI Reference](./cli-reference.md)
- [Type Reference](./reference.md)

--------------------------------------------------------------------------------

- [Contributing](./contributing.md)
  - [Internal Design](./design.md)
    - [JS Objects in Rust](./design/js-objects-in-rust.md)
    - [Exporting a function to JS](./design/exporting-rust.md)
    - [Exporting a struct to JS](./design/exporting-rust-struct.md)
    - [Customizing exports](./design/export-customization.md)
    - [Importing a function from JS](./design/importing-js.md)
    - [Importing a class from JS](./design/importing-js-struct.md)
    - [Customizing imports](./design/import-customization.md)
    - [Rust Type conversions](./design/rust-type-conversions.md)
    - [Types in `wasm-bindgen`](./design/describe.md)
  - [`web-sys`](./web-sys.md)
    - [Overview](./web-sys/overview.md)
    - [Testing](./web-sys/testing.md)
    - [Logging](./web-sys/logging.md)
    - [Supporting More Web APIs](./web-sys/supporting-more-web-apis.md)
  - [Team](./team.md)
